VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmServer 
   Caption         =   "Server"
   ClientHeight    =   2940
   ClientLeft      =   4125
   ClientTop       =   9105
   ClientWidth     =   6675
   LinkTopic       =   "Form1"
   ScaleHeight     =   2940
   ScaleWidth      =   6675
   Begin MSWinsockLib.Winsock TCPServer 
      Index           =   0
      Left            =   6060
      Top             =   2490
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.TextBox Text1 
      Height          =   2715
      Left            =   90
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   120
      Width           =   6480
   End
End
Attribute VB_Name = "frmServer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit


''' MUST BE withevents to receive the data
Private WithEvents oStream        As TCPManagedStream.Stream
Attribute oStream.VB_VarHelpID = -1


'---------------------------------------------------------------------------------------
' Procedure : Sub Form_Load
'---------------------------------------------------------------------------------------
Private Sub Form_Load()
  With TCPServer(0)
    .Close
    .LocalPort = 9999
    .Listen
    Text1.Text = Text1.Text & "Listening on Port 9999" & vbCrLf
  End With
  
  Set oStream = New TCPManagedStream.Stream
End Sub

'---------------------------------------------------------------------------------------
' Procedure : Sub Form_Unload
'---------------------------------------------------------------------------------------
Private Sub Form_Unload(Cancel As Integer)
  Dim x As Integer
  For x = 0 To TCPServer.UBound
    If TCPServer(x).State = sckListening Or TCPServer(x).State = sckConnected Then
      TCPServer(x).Close
    End If
  Next
End Sub


'---------------------------------------------------------------------------------------
' Procedure : Sub TCPServer_ConnectionRequest
'---------------------------------------------------------------------------------------
Private Sub TCPServer_ConnectionRequest(Index As Integer, ByVal requestID As Long)
  Dim i As Integer, j As Integer
  
  If (Index = 0) Then
    ''' Check to see if we've got any sockets that are free.
    For i = 1 To TCPServer.UBound
       If (TCPServer(i).State = sckClosed) Then
          j = i
          Exit For
       End If
    Next i
    
    ''' If we don't have any free sockets, load another on the array.
    If (j = 0) Then
       Call Load(TCPServer(TCPServer.UBound + 1))
       j = TCPServer.Count - 1
    End If
    
    ''' With the selected socket, reset it and accept the new connection.
    With TCPServer(j)
       Call .Close
       Call .Accept(requestID)
       Text1.Text = Text1.Text & "Client Connected" & vbCrLf
    End With
  End If
End Sub
'---------------------------------------------------------------------------------------
' Procedure : Sub TCPServer_Close
'---------------------------------------------------------------------------------------
Private Sub TCPServer_Close(Index As Integer)
  TCPServer(Index).Close
End Sub


Private Sub TCPServer_DataArrival(Index As Integer, ByVal bytesTotal As Long)
  Call oStream.Receive(TCPServer(Index))
End Sub

'---------------------------------------------------------------------------------------
' Procedure : Sub oStream_DataArrivalAsByteString
'---------------------------------------------------------------------------------------
Private Sub oStream_DataArrivalAsByteString(vWinsock As Object, vData As String, ByVal Identifier As Byte)
  Select Case Identifier
    Case 6
      Text1.Text = Text1.Text & "Received Empty String Message : Protocol ID = " & Identifier & vbCrLf
    Case Else
      Text1.Text = Text1.Text & "String : "
      Text1.Text = Text1.Text & vData & vbCrLf
  End Select
  
  '''''''''''''
  ''' IMPORTANT
  '''''''''''''
  ''''''''''''''''''''''''''''''''''
  'DO NOT USE DoEvents IN THIS EVENT, (Bad things will happen)
  ''''''''''''''''''''''''''''''''''
 'DoEvents   No, No, NO !!!!
End Sub

Private Sub oStream_DataArrivalAsByteArray(vWinsock As Object, vData() As Byte, ByVal Identifier As Byte)
  Dim x     As Long
  Dim s     As String
  
  Select Case Identifier
    Case 1    ' Identifier 1 used to identify Uppercase letters
      Text1.Text = Text1.Text & "Expecting Uppercase Letters : "
      For x = 0 To UBound(vData)
        s = s & Chr(vData(x))
      Next
      Text1.Text = Text1.Text & s & vbCrLf
    
    Case 2    ' Identifier 2 used to identify Lowercase letters
      Text1.Text = Text1.Text & "Expecting Lowercase Letters : "
      For x = 0 To UBound(vData)
        s = s & Chr(vData(x))
      Next
      Text1.Text = Text1.Text & s & vbCrLf
    
    Case 6
      Text1.Text = Text1.Text & "Received Empty Byte Array Message : Protocol ID = " & Identifier & vbCrLf
      
    Case Else
      For x = 0 To UBound(vData)
        s = s & Chr(vData(x))
      Next
      Text1.Text = Text1.Text & s & vbCrLf
  End Select
  
  '''''''''''''
  ''' IMPORTANT
  '''''''''''''
  ''''''''''''''''''''''''''''''''''
  'DO NOT USE DoEvents IN THIS EVENT, (Bad things will happen)
  ''''''''''''''''''''''''''''''''''
 'DoEvents  No, No, NO !!!!

End Sub

